package betterwithmods.client.model.generators;

import betterwithmods.BetterWithMods;
import betterwithmods.library.utils.BannerUtils;
import net.minecraft.client.Minecraft;
import net.minecraft.client.model.ModelBase;
import net.minecraft.client.renderer.BannerTextures;
import net.minecraft.util.ResourceLocation;

public class ModelPart extends net.minecraft.client.model.ModelRenderer {
    private ResourceLocation texture;
    private BannerUtils.BannerData banner = null;
    private BannerTextures.Cache cache;

    private boolean hasBanner;


    public ModelPart(ModelBase model) {
        super(model);
    }

    public ModelPart(ModelBase model, int texOffX, int texOffY) {
        super(model, texOffX, texOffY);
    }

    public ModelPart(ModelBase model, String boxNameIn) {
        super(model, boxNameIn);
    }

    @Override
    public void func_78785_a(float scale) {
        if (texture != null) {
            Minecraft.func_71410_x().func_110434_K().func_110577_a(this.texture);
        }
        if (banner != null && cache != null) {
            try {
                ResourceLocation texture = banner.getTexture(cache);
                if (texture != null)
                    Minecraft.func_71410_x().func_110434_K().func_110577_a(texture);
            } catch (Exception e) {
                BetterWithMods.LOGGER.error(e);
            }
        }

        super.func_78785_a(scale);
    }

    public void setBanner(BannerUtils.BannerData banner) {
        this.banner = banner;
    }

    public ModelPart setRotationCenter(float rotationPointXIn, float rotationPointYIn, float rotationPointZIn) {
        super.func_78793_a(rotationPointXIn, rotationPointYIn, rotationPointZIn);
        return this;
    }

    @Override
    public ModelPart func_78789_a(float offX, float offY, float offZ, int width, int height, int depth) {
        return (ModelPart) super.func_78789_a(offX, offY, offZ, width, height, depth);
    }

    @Override
    public ModelPart func_178769_a(float offX, float offY, float offZ, int width, int height, int depth, boolean mirrored) {
        return (ModelPart) super.func_178769_a(offX, offY, offZ, width, height, depth, mirrored);
    }

    @Override
    public ModelPart func_78787_b(int textureWidthIn, int textureHeightIn) {
        return (ModelPart) super.func_78787_b(textureWidthIn, textureHeightIn);
    }

    public ModelPart setTexture(ResourceLocation texture) {
        this.texture = texture;
        if (field_78805_m != null) {
            for (net.minecraft.client.model.ModelRenderer renderer : field_78805_m) {
                if (renderer instanceof ModelPart) {
                    ((ModelPart) renderer).setTexture(this.texture);
                }
            }
        }
        return this;
    }

    @Override
    public ModelPart func_78784_a(int x, int y) {
        return (ModelPart) super.func_78784_a(x, y);
    }

    public ModelPart setRotateAngle(double x, double y, double z) {
        this.field_78795_f = (float) x;
        this.field_78796_g = (float) y;
        this.field_78808_h = (float) z;
        return this;
    }

    public boolean hasBanner() {
        return hasBanner;
    }

    public ModelPart addBanner(BannerTextures.Cache cache) {
        this.hasBanner = true;
        this.cache = cache;
        return this;
    }
}
