package betterwithmods.client.model.generators;

import betterwithmods.client.tesr.TESRVerticalWindmill;
import betterwithmods.client.tesr.TESRWindmill;
import betterwithmods.proxy.BWMClientProxy;
import net.minecraft.util.math.MathHelper;

public class ModelVerticalWindmill extends ModelRadialBlades {

    public ModelVerticalWindmill() {
        super(8);
    }

    @Override
    protected ModelPart createBlade(int index) {

        ModelPart part = new ModelPart(this, 0, 0);

        float angle = (float) ((Math.PI * 2 * index) / bladeCount);
        float radius = 72.5f;


        float x = radius * MathHelper.func_76126_a(angle), z = radius * MathHelper.func_76134_b(angle);

        double sailAngle = (Math.PI / (bladeCount * 2));

        int height = 100;
        int arm_size = 2, shaft_size = 4;
        int arm_length = (int) (radius) - shaft_size;
        int border_length = 52;

        float top = height / 2, bottom = -top;

        //Sails
        part.func_78792_a(new ModelPart(this, 0, 0)
                .addBanner(BWMClientProxy.WINDMILLS)
                .func_78787_b(128, 128)
                .func_178769_a(0, 0, 0, 20, 100, 1, true)
                .setRotationCenter(x, -50, z)
                .setRotateAngle(0, angle + sailAngle, 0)
                .setTexture(TESRWindmill.WINDMILL_SAIL)
        );

        int shaft_height = height + arm_size * 2;
        float shaft_top = shaft_height / 2, shaft_bottom = -shaft_top;
        //Shafts
        part.func_78792_a(new ModelPart(this, 0, 0)
                .func_78787_b(16, 16)
                .func_78789_a(radius - shaft_size, shaft_bottom, -2.0F, shaft_size, shaft_height, shaft_size)
                .setRotationCenter(0.0F, 0.0F, 0.0F)
                .setRotateAngle(0, angle, 0)
                .setTexture(TESRVerticalWindmill.WINDMILL_SHAFTS)
        );

        //Frame Arms
        part.func_78792_a(new ModelPart(this, 0, 0)
                .func_78787_b(16, 16)
                .func_78789_a(arm_size, top, -arm_size / 2, arm_length, arm_size, arm_size)
                .func_78789_a(arm_size, bottom, -arm_size / 2, arm_length, arm_size, arm_size)
                .setRotationCenter(0.0F, 0.0F, 0.0F)
                .setRotateAngle(0, angle, 0)
                .setTexture(TESRVerticalWindmill.WINDMILL_FRAME)
        );

        //Frame Border
        part.func_78792_a(new ModelPart(this, 0, 0)
                .func_78787_b(16, 16)
                .func_78789_a(radius - (2 * shaft_size), bottom, -26f, arm_size, arm_size, border_length)
                .func_78789_a(radius - (2 * shaft_size), top, -26f, arm_size, arm_size, border_length)
                .setRotationCenter(0.0F, 0.0F, 0.0F)
                .setRotateAngle(0, angle + 0.39F, 0)
                .setTexture(TESRVerticalWindmill.WINDMILL_FRAME)
        );

        return part;
    }
}
