package betterwithmods.common.blocks.mechanical.cookingpot;

import betterwithmods.BetterWithMods;
import betterwithmods.common.tile.TileCookingPot;
import betterwithmods.library.common.block.BlockBase;
import betterwithmods.library.common.tile.TileVisibleInventory;
import betterwithmods.library.utils.CapabilityUtils;
import betterwithmods.library.utils.DirUtils;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;

/**
 * Purpose:
 *
 * @author primetoxinz
 * @version 3/3/17
 */
public class BlockCookingPot extends BlockBase {

    private static final AxisAlignedBB BOX = new AxisAlignedBB(0, 0, 0, 1, 0.99d, 1),
            SELECTION_BOX = new AxisAlignedBB(0, 0, 0, 1, 1, 1);

    public BlockCookingPot() {
        super(Material.field_151576_e);
        this.func_149711_c(3.5F);
        func_149672_a(SoundType.field_185851_d);
    }

    @Nonnull
    @Override
    @SideOnly(Side.CLIENT)
    public BlockRenderLayer func_180664_k() {
        return BlockRenderLayer.CUTOUT_MIPPED;
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149730_j(IBlockState state) {
        return false;
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_176214_u(IBlockState state) {
        return false;
    }


    @Override
    public IProperty<?>[] getProperties() {
        return new IProperty[]{DirUtils.TILTING};
    }


    @Override
    public AxisAlignedBB func_180640_a(IBlockState state, World worldIn, BlockPos pos) {
        return SELECTION_BOX.func_186670_a(pos);
    }

    @SuppressWarnings("deprecation")
    @Nonnull
    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
        return BOX;
    }


    @Override
    public void func_180634_a(World worldIn, BlockPos pos, IBlockState state, Entity entityIn) {
        if (!worldIn.field_72995_K) {
            TileEntity tile = worldIn.func_175625_s(pos);
            if (tile instanceof TileCookingPot) {
                TileCookingPot pot = (TileCookingPot) tile;
                pot.insert(entityIn);
            }
        }
        if (entityIn instanceof EntityItem) {
            entityIn.func_70107_b(entityIn.field_70165_t, entityIn.field_70163_u + 0.1, entityIn.field_70161_v); //Fix to stop items being caught on this
        }
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
        if (!player.func_70093_af() && !world.field_72995_K) {
            TileEntity tile = world.func_175625_s(pos);
            if (tile != null && CapabilityUtils.hasInventory(tile, null)) {
                player.openGui(BetterWithMods.instance, 0, world, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
            }
        }
        return true;
    }

    @Override
    public boolean hasTileEntity(IBlockState state) {
        return true;
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return 0;
    }

    @Nonnull
    @Override
    public IBlockState func_176203_a(int meta) {
        return func_176223_P();
    }

    @Override
    public boolean func_149740_M(IBlockState state) {
        return true;
    }

    protected int getComparatorFromTile(TileEntity tile) {
        if (tile instanceof TileVisibleInventory) {
            return (int) (((TileVisibleInventory) tile).getPercentage() * 15);
        }
        return 0;
    }

    @Override
    public int func_180641_l(IBlockState blockState, World worldIn, BlockPos pos) {
        TileEntity tile = worldIn.func_175625_s(pos);
        return getComparatorFromTile(tile);
    }
}
