package betterwithmods.common.blocks.mechanical.mech_machine;

import betterwithmods.api.block.IUrnConnector;
import betterwithmods.common.tile.TileFilteredHopper;
import betterwithmods.lib.ModLib;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraft.world.storage.loot.LootTableList;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;

public class BlockFilteredHopper extends BlockMechMachine implements IUrnConnector {
    public static final ResourceLocation HOPPER = LootTableList.func_186375_a(new ResourceLocation(ModLib.MODID, "block/hopper"));

    private static final AxisAlignedBB BOX = new AxisAlignedBB(0, 4 / 16d, 0, 1, 0.99d, 1),
            SELECTION_BOX = new AxisAlignedBB(0, 4 / 16d, 0, 1, 1, 1);
    public BlockFilteredHopper() {
        super(Material.field_151575_d, HOPPER);
        this.field_149783_u = true;
    }

    @Override
    public void func_180634_a(World worldIn, BlockPos pos, IBlockState state, Entity entityIn) {
        if (!worldIn.field_72995_K) {
            TileEntity tile = worldIn.func_175625_s(pos);
            if (tile instanceof TileFilteredHopper) {
                TileFilteredHopper hopper = (TileFilteredHopper) tile;
                hopper.insert(entityIn);
            }
        }
        if (entityIn instanceof EntityItem) {
            entityIn.func_70107_b(entityIn.field_70165_t, entityIn.field_70163_u + 0.1, entityIn.field_70161_v); //Fix to stop items being caught on this
        }
    }

    @Override
    public TileEntity createTileEntity(@Nonnull World world, @Nonnull IBlockState state) {
        return new TileFilteredHopper();
    }

    @Override
    public AxisAlignedBB func_180640_a(IBlockState state, World worldIn, BlockPos pos) {
        return SELECTION_BOX.func_186670_a(pos);
    }

    @SuppressWarnings("deprecation")
    @Nonnull
    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
        return BOX;
    }

    @Override
    public int func_149738_a(World worldIn) {
        return 10;
    }

    @Override
    public boolean isSideSolid(IBlockState state, @Nonnull IBlockAccess world, @Nonnull BlockPos pos, EnumFacing side) {
        return false;
    }


    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149730_j(IBlockState state) {
        return false;
    }


    @SuppressWarnings("deprecation")
    @Override
    public boolean func_176214_u(IBlockState state) {
        return false;
    }

    @Nonnull
    @Override
    @SideOnly(Side.CLIENT)
    public BlockRenderLayer func_180664_k() {
        return BlockRenderLayer.CUTOUT_MIPPED;
    }
}

