package betterwithmods.common.blocks.mechanical.mech_machine;

import betterwithmods.common.tile.TileMill;
import betterwithmods.lib.ModLib;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.storage.loot.LootTableList;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;
import java.util.Random;

public class BlockMillstone extends BlockMechMachine {
    public static final ResourceLocation MILLSTONE = LootTableList.func_186375_a(new ResourceLocation(ModLib.MODID, "block/mill"));


    public BlockMillstone() {
        super(Material.field_151576_e, MILLSTONE);
    }

    @Override
    public int func_149738_a(World worldIn) {
        return 1;
    }

    @Override
    public TileEntity createTileEntity(@Nonnull World world, @Nonnull IBlockState state) {
        return new TileMill();
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_180655_c(IBlockState state, World world, BlockPos pos, Random rand) {
        if (isActive(state)) {
            emitSmoke(world, pos, rand);
        }
    }

    private void emitSmoke(World world, BlockPos pos, Random rand) {
        for (int i = 0; i < 5; i++) {
            int x = pos.func_177958_n();
            int y = pos.func_177956_o();
            int z = pos.func_177952_p();
            float fX = x + rand.nextFloat();
            float fY = y + rand.nextFloat() * 0.5F + 1.0F;
            float fZ = z + rand.nextFloat();
            world.func_175688_a(EnumParticleTypes.SMOKE_NORMAL, fX, fY, fZ, 0.0D, 0.0D, 0.0D);
        }
    }
}
