package betterwithmods.common.registry.anvil;

import betterwithmods.common.registry.base.CraftingManagerBase;
import betterwithmods.lib.ModLib;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.CraftingManager;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.util.NonNullList;
import net.minecraft.util.ResourceLocation;
import net.minecraft.world.World;

public class CraftingManagerAnvil extends CraftingManagerBase<AnvilRecipe> {

    private IRecipe recipe;

    public CraftingManagerAnvil() {
        super(new ResourceLocation(ModLib.MODID, "anvil"), AnvilRecipe.class);
    }

    /**
     * Retrieves an ItemStack that has multiple recipes for it.
     */
    public ItemStack findMatchingResult(InventoryCrafting inventory, World world) {

        if (recipe != null && recipe.func_77569_a(inventory, world)) {
            return recipe.func_77572_b(inventory);
        }

        for (AnvilRecipe irecipe : getValuesCollection()) {
            if (irecipe.matches(inventory, world)) {
                recipe = irecipe.getRecipe();
                return irecipe.getCraftingResult(inventory);
            }
        }

        for (IRecipe irecipe : CraftingManager.field_193380_a) {
            if (irecipe.func_77569_a(inventory, world)) {
                recipe = irecipe;
                return irecipe.func_77572_b(inventory);
            }
        }

        return ItemStack.field_190927_a;
    }


    public NonNullList<ItemStack> getRemainingItems(InventoryCrafting inventory, World craftMatrix) {

        if (recipe != null && recipe.func_77569_a(inventory, craftMatrix)) {
            return recipe.func_179532_b(inventory);
        }

        for (AnvilRecipe irecipe : getValuesCollection()) {
            if (irecipe.matches(inventory, craftMatrix)) {
                recipe = irecipe.getRecipe();
                return irecipe.getRemainingItems(inventory);
            }
        }

        for (IRecipe irecipe : CraftingManager.field_193380_a) {
            if (irecipe.func_77569_a(inventory, craftMatrix)) {
                recipe = irecipe;
                return irecipe.func_179532_b(inventory);
            }
        }

        NonNullList<ItemStack> nonnulllist = NonNullList.func_191197_a(inventory.func_70302_i_(), ItemStack.field_190927_a);

        for (int i = 0; i < nonnulllist.size(); ++i) {
            nonnulllist.set(i, inventory.func_70301_a(i));
        }

        return nonnulllist;
    }
}
