package betterwithmods.common.tile;

import betterwithmods.api.tile.IBannerInfo;
import betterwithmods.library.utils.BannerUtils;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.DimensionType;

import javax.annotation.Nonnull;

public abstract class TileBaseWindmill extends TileAxleGenerator implements IBannerInfo {

    protected int bannerIndex;
    protected BannerUtils.BannerData[] banners;
    private int blades;

    public TileBaseWindmill(int blades) {
        this.blades = blades;
        this.banners = new BannerUtils.BannerData[this.blades];
    }

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);
        bannerIndex = tag.func_74762_e("BannerIndex");
        BannerUtils.readArray(banners, tag);
    }

    @Nonnull
    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        NBTTagCompound t = super.func_189515_b(tag);
        tag.func_74768_a("BannerIndex", bannerIndex);
        BannerUtils.writeArray(banners, t);
        return t;
    }

    @Override
    public void calculatePower() {
        byte power = 0;
        if (isValid()) {
            if (field_145850_b.field_73011_w.func_186058_p() == DimensionType.OVERWORLD) {
                if (field_145850_b.func_72911_I())
                    power = 3;
                else if (field_145850_b.func_72896_J())
                    power = 2;
                else
                    power = 1;
            } else {
                power = 1;
            }
        }

        if (power != this.power) {
            setPower(power);
        }
    }


    @Override
    public int getMinimumInput(EnumFacing facing) {
        return 0;
    }

    @Override
    public int getSelected() {
        return bannerIndex;
    }

    @Override
    public void next() {
        bannerIndex = (bannerIndex + 1) % blades;
    }


    @Override
    public void setBannerData(int selected, BannerUtils.BannerData data) {
        banners[selected] = data;
        func_70296_d();
    }

    @Override
    public BannerUtils.BannerData[] getData() {
        return banners;
    }


}


