package betterwithmods.common.tile;

import betterwithmods.common.blocks.BlockLamp;
import betterwithmods.library.common.tile.TileBasic;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nonnull;

public class TileLamp extends TileBasic {

    private int color;
    private boolean inverted = false;

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound compound) {

        compound.func_74768_a("color", color);
        compound.func_74757_a("inverted", inverted);

        return super.func_189515_b(compound);
    }

    @Override
    public void func_145839_a(NBTTagCompound compound) {
        color = value(compound, "color", 0);
        inverted = value(compound, "inverted", false);
        super.func_145839_a(compound);
    }

    public int getColor() {
        return color;
    }

    public void setColor(int color) {
        this.color = color;
    }

    public boolean isInverted() {
        return inverted;
    }

    public void setInverted(boolean inverted) {
        this.inverted = inverted;
    }

    public void fromItemStack(ItemStack stack) {
        NBTTagCompound tag = stack.func_77978_p();
        if (tag != null) {
            color = value(tag, "color", 0);
            inverted = value(tag, "inverted", false);
        }
    }

    public ItemStack getItemStack() {
        return BlockLamp.createLamp(getColor(), isInverted());
    }

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, @Nonnull IBlockState oldState, @Nonnull IBlockState newState) {
        return oldState.func_177230_c() != newState.func_177230_c();
    }
}
