package betterwithmods.common.tile;

import betterwithmods.common.BWMBlocks;
import betterwithmods.library.utils.DirUtils;
import betterwithmods.util.WorldUtils;
import net.minecraft.block.state.IBlockState;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;

public class TileWindmillHorizontal extends TileBaseWindmill {

    public TileWindmillHorizontal() {
        super(4);
    }

    @Override
    public void verifyIntegrity() {
        boolean valid = true;
        if (getBlockWorld().func_180495_p(field_174879_c).func_177230_c() == BWMBlocks.HORIZONTAL_WINDMILL) {
            EnumFacing.Axis axis = getBlockWorld().func_180495_p(field_174879_c).func_177229_b(DirUtils.AXIS);
            for (int vert = -getRadius(); vert <= getRadius(); vert++) {
                for (int i = -getRadius(); i <= getRadius(); i++) {
                    int xP = (axis == EnumFacing.Axis.Z ? i : 0);
                    int zP = (axis == EnumFacing.Axis.X ? i : 0);
                    BlockPos offset = field_174879_c.func_177982_a(xP, vert, zP);
                    if (xP == 0 && vert == 0 && zP == 0)
                        continue;
                    else {
                        IBlockState state = field_145850_b.func_180495_p(offset);
                        valid = state.func_177230_c().func_176200_f(field_145850_b, offset);
                    }
                    if (!valid)
                        break;
                }
                if (!valid)
                    break;
            }
        }
        isValid = valid && this.getBlockWorld().func_175710_j(field_174879_c) && !WorldUtils.isNether(field_145850_b) && !WorldUtils.isTheEnd(field_145850_b);
    }

    @Override
    public int getRadius() {
        return 7;
    }


}
