package betterwithmods.module.general.moreheads.common;

import betterwithmods.library.utils.DirUtils;
import betterwithmods.module.general.moreheads.client.TEISRHead;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentTranslation;
import net.minecraft.world.World;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class ItemHead extends ItemBlock {

    private Block head;

    public ItemHead(Block block) {
        super(block);
        this.head = block;
        this.func_77627_a(true);
        setTileEntityItemStackRenderer(new TEISRHead());
    }

    @Nonnull
    @Override
    public EnumActionResult func_180614_a(EntityPlayer player, World worldIn, BlockPos pos, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
        if (facing == EnumFacing.DOWN)
            return EnumActionResult.FAIL;


        if (worldIn.func_180495_p(pos).func_177230_c().func_176200_f(worldIn, pos)) {
            facing = EnumFacing.UP;
            pos = pos.func_177977_b();
        }
        IBlockState iblockstate = worldIn.func_180495_p(pos);
        Block block = iblockstate.func_177230_c();
        boolean replaceable = block.func_176200_f(worldIn, pos);

        if (!replaceable) {
            if (!worldIn.func_180495_p(pos).func_185904_a().func_76220_a() && !worldIn.isSideSolid(pos, facing, true)) {
                return EnumActionResult.FAIL;
            }
            pos = pos.func_177972_a(facing);
        }


        ItemStack itemstack = player.func_184586_b(hand);

        if (player.func_175151_a(pos, facing, itemstack) && head.func_176196_c(worldIn, pos)) {
            if (worldIn.field_72995_K) {
                return EnumActionResult.SUCCESS;
            } else {
                worldIn.func_180501_a(pos, head.func_176223_P().func_177226_a(DirUtils.FACING, facing), 11);
                TileEntity tile = worldIn.func_175625_s(pos);
                if (tile instanceof TileHead) {
                    TileHead head = (TileHead) tile;
                    if(facing == EnumFacing.UP) {
                        head.setRotation(MathHelper.func_76128_c((double)(player.field_70177_z * 16.0F / 360.0F) + 0.5D) & 15);
                    }
                    head.setType(getHeadType(itemstack));
                    tile.func_70296_d();
                    itemstack.func_190918_g(1);
                }

                return EnumActionResult.SUCCESS;
            }
        }
        return EnumActionResult.FAIL;
    }


    public static HeadType getHeadType(ItemStack stack) {
        if (stack.func_77942_o()) {
            NBTTagCompound tag = stack.func_77978_p();
            if (tag != null) {
                return HeadType.getValue(tag.func_74779_i("type"));
            }
        }
        return null;
    }

    @Nonnull
    @Override
    public String func_77653_i(@Nonnull ItemStack stack) {

        HeadType type = getHeadType(stack);
        if (type != null) {
            ITextComponent item = new TextComponentTranslation(this.func_77667_c(stack) + ".name");
            ITextComponent text = new TextComponentTranslation(type.getEntityUnlocalizedName());
            return text.func_150258_a(" ").func_150257_a(item).func_150254_d();
        }
        return super.func_77653_i(stack);
    }

    @Nullable
    @Override
    public EntityEquipmentSlot getEquipmentSlot(ItemStack stack) {
        return EntityEquipmentSlot.HEAD;
    }
}
