package betterwithmods.module.tweaks;

import betterwithmods.common.BWMItems;
import betterwithmods.library.common.modularity.impl.Feature;
import net.minecraft.entity.passive.EntityBat;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

import static betterwithmods.library.utils.EntityUtils.addDrop;


public class BatWings extends Feature {

    @SubscribeEvent
    public void onDeath(LivingDropsEvent event) {
        World world = event.getEntityLiving().func_130014_f_();
        if (event.getEntityLiving() instanceof EntityBat) {
            int count = event.getLootingLevel() > 0 ? Math.min(2, event.getLootingLevel()) : world.field_73012_v.nextInt(2);
            addDrop(event, new ItemStack(BWMItems.BAT_WING, count));
        }
    }

    @Override
    public String getDescription() {
        return "Add a Bat Wing drop to bats";
    }

    @Override
    public String[] getIncompatibleMods() {
        return new String[]{"actuallyadditions"};
    }

    @Override
    public boolean hasEvent() {
        return true;
    }
}
