package betterwithmods.module.tweaks;

import betterwithmods.common.registry.block.recipe.builder.KilnRecipeBuilder;
import betterwithmods.library.common.modularity.impl.Feature;
import betterwithmods.module.internal.RecipeRegistry;
import com.google.common.collect.Lists;
import net.minecraft.init.Items;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
import net.minecraftforge.oredict.OreDictionary;

import java.util.List;


/**
 * Created by primetoxinz on 5/16/17.
 */
public class KilnCharcoal extends Feature {

    private static final ItemStack CHARCOAL = new ItemStack(Items.field_151044_h, 1, 1);
    private boolean disableFurnaceCharcoal;

    @Override
    public String getDescription() {
        return "Add Charcoal smelting to the Kiln";
    }

    @Override
    public void onPostInit(FMLPostInitializationEvent event) {
        disableFurnaceCharcoal = loadProperty("Disable Furnace Charcoal", true).setComment("Remove recipes to make Charcoal in a Furnace").get();
        List<ItemStack> logs = Lists.newArrayList();
        logs.addAll(OreDictionary.getOres("logWood"));

        KilnRecipeBuilder builder = new KilnRecipeBuilder();

        for (ItemStack stack : logs) {
            if (stack.func_77973_b() instanceof ItemBlock) {
                ItemStack charcoalOutput = FurnaceRecipes.func_77602_a().func_151395_a(stack).func_77946_l();
                if (charcoalOutput.func_190926_b())
                    continue;
                if (disableFurnaceCharcoal)
                    RecipeRegistry.removeFurnaceRecipe(stack);
                RecipeRegistry.KILN.register(builder.stoked().input(stack).outputs(charcoalOutput).build());
            }
        }
    }


}
